<script>
    import { scaleLog } from 'd3-scale';
    import { area } from 'd3-shape';
    import { extent } from 'd3-array';

    const width = 600;
    const height = 250;
    const margin = { top: 10, right: 10, bottom: 10, left: 10 };
    const innerHeight = height - margin.top - margin.bottom;

    export let offset = null;
    export let data = null;
    export let city = null;
    const radius = 60;
    const cx = offset - 95;
    const cy = innerHeight / 2;
    const heatingScaler = scaleLog().range([1, radius]).domain(extent(data.map(d => d.heating)))
    const coolingScaler = scaleLog().range([1, radius]).domain(extent(data.map(d => d.cooling)))

    function calculateX(scale_length, day_of_year) {
        return scale_length * Math.sin(2 * Math.PI * day_of_year / 365) + cx
    }

    function calculateY(scale_length, day_of_year) {
        return -scale_length * Math.cos(2 * Math.PI * day_of_year / 365) + cy
    }
    const heatingArea = area()
        .x(function(d) {
            return calculateX(heatingScaler(d.heating), d.day_of_year)
        })
        .y0(function(d) {
            return cy
        })
        .y1(function(d) {
            return calculateY(heatingScaler(d.heating), d.day_of_year)
        })
    const coolingArea = area()
        .x(function(d) {
            return calculateX(coolingScaler(d.cooling), d.day_of_year)
        }) 
        .y0(function(d) {
            return cy
        })
        .y1(function(d) {
            return calculateY(coolingScaler(d.cooling), d.day_of_year)
        })
</script>

<circle cx={cx}
        cy={cy}
        r={radius}
        stroke=black
        fill=transparent
        stroke-width=2></circle>
<line x1={cx-radius} y1={cy} x2={cx+radius} y2={cy} stroke=black></line>
<line x1={cx} y1={cy-radius} x2={cx} y2={cy+radius} stroke=black></line>
<text x={cx-30} y={cy-radius-30}>{city}</text>
<text x={cx-5} y={cy-radius-4}>0</text>
<text x={cx+radius+4} y={cy+4}>3</text>
<text x={cx-5} y={cy+radius+16}>6</text>
<text x={cx-radius-14} y={cy+4}>9</text>
<path stroke="red" fill="red" d="{heatingArea(data)}" class="area" style="opacity: 0.7;"/>
<path stroke="blue" fill="blue" d="{coolingArea(data)}" class="area" style="opacity: 0.7;"/>
